%global _hardened_build 1

Name:           up-imapproxy
Summary:        University of Pittsburgh IMAP Proxy
Version:        1.2.8
Release:    1%{?dist}
License:        GPLv2+
URL:            http://www.imapproxy.org
Source0:        squirrelmail-imap_proxy-20171022svn14722.tar.gz
Source1:        imapproxy.service
Patch0:         http://ausil.fedorapeople.org/aarch64/up-imapproxy/up-imapproxy-aarch64.patch
Patch1:         up-imapproxy-ssl.patch
Patch2:         up-imapproxy-configure-c99.patch
Patch3:         up-imapproxy-c99.patch
BuildRequires: make
BuildRequires:  gcc
BuildRequires:  openssl-devel ncurses-devel
Requires(pre): shadow-utils
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
BuildRequires: systemd

%description
imapproxy was written to compensate for webmail clients that are
unable to maintain persistent connections to an IMAP server. Most
webmail clients need to log in to an IMAP server for nearly every
single transaction. This behaviour can cause tragic performance
problems on the IMAP server. imapproxy tries to deal with this problem
by leaving server connections open for a short time after a webmail
client logs out. When the webmail client connects again, imapproxy
will determine if there's a cached connection available and reuse it
if possible.

%prep
%setup -q -n squirrelmail-imap_proxy-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1

sed -i \
    -e 's/  *$//' \
    -e 's!/usr/share/ssl!/etc/pki/tls!' \
    -e 's/^\(proc_username\) .*/\1 imapproxy/' \
    -e 's/^\(proc_groupname\) .*/\1 imapproxy/' \
    -e 's!^#*\(chroot_directory\) .*!\1 /var/lib/imapproxy!' \
    -e 's/^\(foreground_mode\) .*/\1 yes/' \
    scripts/imapproxy.conf

%build
%configure
[ -d bin ] || mkdir bin
make %{?_smp_mflags}

%install
install -D -m 0644 -p scripts/imapproxy.conf \
    %{buildroot}%{_sysconfdir}/imapproxy.conf
install -D -m 0755 -p %{SOURCE1} %{buildroot}%{_unitdir}/imapproxy.service
install -d -m 0755 %{buildroot}%{_sbindir}
install -D -m 0755 bin/* %{buildroot}%{_sbindir}

install -d -m 0755 %{buildroot}/var/lib/imapproxy

%pre
getent group imapproxy >/dev/null || groupadd -r imapproxy
getent passwd imapproxy >/dev/null || \
    useradd -r -g imapproxy -d /var/lib/imapproxy -s /sbin/nologin \
    -c "IMAP proxy service" imapproxy
exit 0

%post
%systemd_post imapproxy.service

%preun
%systemd_preun imapproxy.service

%postun
%systemd_postun_with_restart imapproxy.service 

%files
%doc COPYING ChangeLog README README.ssl
%doc copyright
%config(noreplace) %{_sysconfdir}/imapproxy.conf
%{_unitdir}/imapproxy.service
%{_sbindir}/in.imapproxyd
%{_sbindir}/pimpstat
%dir /var/lib/imapproxy

%changelog
* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.2.8-1
- initial build
